diff --git a/src/plugins/pluginTaglib/coverReaderTaglib.cpp b/src/plugins/pluginTaglib/coverReaderTaglib.cpp
index 398c968..37667fd 100644
--- a/src/plugins/pluginTaglib/coverReaderTaglib.cpp
+++ b/src/plugins/pluginTaglib/coverReaderTaglib.cpp
@@ -79,7 +79,7 @@ QList<QImage> NCoverReaderTaglib::fromApe(TagLib::APE::Tag *tag) const
     QList<QImage> images;
     const TagLib::APE::ItemListMap &map = tag->itemListMap();
 
-    for (auto iter = map.begin(); iter != map.end(); ++iter) {
+    for (TagLib::APE::ItemListMap::ConstIterator iter = map.begin(); iter != map.end(); ++iter) {
         TagLib::String key = iter->first;
         if (!key.startsWith("COVER ART")) {
             continue;
@@ -105,8 +105,8 @@ QList<QImage> NCoverReaderTaglib::fromAsf(TagLib::ASF::Tag *tag) const
 
     const TagLib::ASF::AttributeList &list = map[str];
 
-    for (auto attribute : list) {
-        TagLib::ASF::Picture pic = attribute.toPicture();
+    for (TagLib::ASF::AttributeList::ConstIterator it = list.begin(); it != list.end(); ++it) {
+        TagLib::ASF::Picture pic = it->toPicture();
         if (pic.isValid()) {
             images << fromTagBytes(pic.picture());
         }
@@ -120,8 +120,8 @@ QList<QImage> NCoverReaderTaglib::fromFlac(TagLib::FLAC::File *file) const
     QList<QImage> images;
     const TagLib::List<TagLib::FLAC::Picture *> &list = file->pictureList();
 
-    for (TagLib::FLAC::Picture *pic : list) {
-        images << fromTagBytes(pic->data());
+    for (TagLib::List<TagLib::FLAC::Picture *>::ConstIterator it = list.begin(); it != list.end(); ++it) {
+        images << fromTagBytes((*it)->data());
     }
     return images;
 }
@@ -134,8 +134,8 @@ QList<QImage> NCoverReaderTaglib::fromId3(TagLib::ID3v2::Tag *tag) const
         return images;
     }
 
-    for (auto *frame : list) {
-        auto pictureFrame = static_cast<TagLib::ID3v2::AttachedPictureFrame *>(frame);
+    for (TagLib::ID3v2::FrameList::ConstIterator it = list.begin(); it != list.end(); ++it) {
+        TagLib::ID3v2::AttachedPictureFrame *pictureFrame = static_cast<TagLib::ID3v2::AttachedPictureFrame *>(*it);
         images << fromTagBytes(pictureFrame->picture());
     }
     return images;
@@ -150,8 +150,8 @@ QList<QImage> NCoverReaderTaglib::fromMp4(TagLib::MP4::Tag *tag) const
     }
 
     TagLib::MP4::CoverArtList coverList = tag->itemMap()[str].toCoverArtList();
-    for (auto coverArt : coverList) {
-        images << fromTagBytes(coverArt.data());
+    for (TagLib::MP4::CoverArtList::ConstIterator it = coverList.begin(); it != coverList.end(); ++it) {
+        images << fromTagBytes(it->data());
     }
 
     return images;
@@ -160,7 +160,7 @@ QList<QImage> NCoverReaderTaglib::fromMp4(TagLib::MP4::Tag *tag) const
 QList<QImage> NCoverReaderTaglib::fromVorbis(TagLib::Tag *tag) const
 {
     QList<QImage> images;
-    if (auto *comment = dynamic_cast<TagLib::Ogg::XiphComment *>(tag)) {
+    if (TagLib::Ogg::XiphComment *comment = dynamic_cast<TagLib::Ogg::XiphComment *>(tag)) {
         TagLib::String str = "COVERART";
 
         if (!comment->contains(str)) {
@@ -193,29 +193,29 @@ QList<QImage> NCoverReaderTaglib::getImages() const
 
     TagLib::File *tagFile = NTaglib::_tagRef->file();
 
-    if (auto *file = dynamic_cast<TagLib::APE::File *>(tagFile)) {
+    if (TagLib::APE::File *file = dynamic_cast<TagLib::APE::File *>(tagFile)) {
         if (file->APETag()) {
             images = fromApe(file->APETag());
         }
-    } else if (auto *file = dynamic_cast<TagLib::ASF::File *>(tagFile)) {
+    } else if (TagLib::ASF::File *file = dynamic_cast<TagLib::ASF::File *>(tagFile)) {
         if (file->tag()) {
             images = fromAsf(file->tag());
         }
-    } else if (auto *file = dynamic_cast<TagLib::FLAC::File *>(tagFile)) {
+    } else if (TagLib::FLAC::File *file = dynamic_cast<TagLib::FLAC::File *>(tagFile)) {
         images = fromFlac(file);
 
         if (images.isEmpty() && file->ID3v2Tag()) {
             images = fromId3(file->ID3v2Tag());
         }
-    } else if (auto *file = dynamic_cast<TagLib::MP4::File *>(tagFile)) {
+    } else if (TagLib::MP4::File *file = dynamic_cast<TagLib::MP4::File *>(tagFile)) {
         if (file->tag()) {
             images = fromMp4(file->tag());
         }
-    } else if (auto *file = dynamic_cast<TagLib::MPC::File *>(tagFile)) {
+    } else if (TagLib::MPC::File *file = dynamic_cast<TagLib::MPC::File *>(tagFile)) {
         if (file->APETag()) {
             images = fromApe(file->APETag());
         }
-    } else if (auto *file = dynamic_cast<TagLib::MPEG::File *>(tagFile)) {
+    } else if (TagLib::MPEG::File *file = dynamic_cast<TagLib::MPEG::File *>(tagFile)) {
         if (file->ID3v2Tag()) {
             images = fromId3(file->ID3v2Tag());
         }
@@ -223,11 +223,11 @@ QList<QImage> NCoverReaderTaglib::getImages() const
         if (images.isEmpty() && file->APETag()) {
             images = fromApe(file->APETag());
         }
-    } else if (auto *file = dynamic_cast<TagLib::Ogg::Vorbis::File *>(tagFile)) {
+    } else if (TagLib::Ogg::Vorbis::File *file = dynamic_cast<TagLib::Ogg::Vorbis::File *>(tagFile)) {
         if (file->tag()) {
             images = fromVorbis(file->tag());
         }
-    } else if (auto *file = dynamic_cast<TagLib::WavPack::File *>(tagFile)) {
+    } else if (TagLib::WavPack::File *file = dynamic_cast<TagLib::WavPack::File *>(tagFile)) {
         if (file->APETag()) {
             images = fromApe(file->APETag());
         }
diff --git a/src/plugins/pluginTaglib/tagReaderTaglib.cpp b/src/plugins/pluginTaglib/tagReaderTaglib.cpp
index c54f711..26af1f1 100644
--- a/src/plugins/pluginTaglib/tagReaderTaglib.cpp
+++ b/src/plugins/pluginTaglib/tagReaderTaglib.cpp
@@ -35,7 +35,7 @@ QString NTaglib::_filePath;
 NTagReaderTaglib::NTagReaderTaglib(QObject *parent) : NTagReaderInterface(parent)
 {
     m_isValid = false;
-    m_codec = nullptr;
+    m_codec = 0;
     m_utf8Codec = QTextCodec::codecForName("UTF-8");
 }
 
@@ -141,19 +141,19 @@ QString NTagReaderTaglib::getTag(QChar ch) const
         }
         case 'b': { // bit depth
             TagLib::AudioProperties *ap = NTaglib::_tagRef->audioProperties();
-            if (auto *prop = dynamic_cast<TagLib::APE::Properties *>(ap)) {
+            if (TagLib::APE::Properties *prop = dynamic_cast<TagLib::APE::Properties *>(ap)) {
                 return QString::number(prop->bitsPerSample());
-            } else if (auto *prop = dynamic_cast<TagLib::FLAC::Properties *>(ap)) {
+            } else if (TagLib::FLAC::Properties *prop = dynamic_cast<TagLib::FLAC::Properties *>(ap)) {
                 return QString::number(prop->bitsPerSample());
-            } else if (auto *prop = dynamic_cast<TagLib::MP4::Properties *>(ap)) {
+            } else if (TagLib::MP4::Properties *prop = dynamic_cast<TagLib::MP4::Properties *>(ap)) {
                 return QString::number(prop->bitsPerSample());
-            } else if (auto *prop = dynamic_cast<TagLib::RIFF::AIFF::Properties *>(ap)) {
+            } else if (TagLib::RIFF::AIFF::Properties *prop = dynamic_cast<TagLib::RIFF::AIFF::Properties *>(ap)) {
                 return QString::number(prop->bitsPerSample());
-            } else if (auto *prop = dynamic_cast<TagLib::RIFF::WAV::Properties *>(ap)) {
+            } else if (TagLib::RIFF::WAV::Properties *prop = dynamic_cast<TagLib::RIFF::WAV::Properties *>(ap)) {
                 return QString::number(prop->bitsPerSample());
-            } else if (auto *prop = dynamic_cast<TagLib::TrueAudio::Properties *>(ap)) {
+            } else if (TagLib::TrueAudio::Properties *prop = dynamic_cast<TagLib::TrueAudio::Properties *>(ap)) {
                 return QString::number(prop->bitsPerSample());
-            } else if (auto *prop = dynamic_cast<TagLib::WavPack::Properties *>(ap)) {
+            } else if (TagLib::WavPack::Properties *prop = dynamic_cast<TagLib::WavPack::Properties *>(ap)) {
                 return QString::number(prop->bitsPerSample());
             } else {
                 return "";
@@ -264,11 +264,11 @@ QMap<QString, QStringList>
 NTagReaderTaglib::TMapToQMap(const TagLib::Map<TagLib::String, TagLib::StringList> &tmap) const
 {
     QMap<QString, QStringList> qmap;
-    for (auto iter = tmap.begin(); iter != tmap.end(); ++iter) {
+    for (TagLib::Map<TagLib::String, TagLib::StringList>::ConstIterator iter = tmap.begin(); iter != tmap.end(); ++iter) {
         QStringList values;
         TagLib::StringList tlist = iter->second;
-        for (auto iter = tlist.begin(); iter != tlist.end(); ++iter) {
-            values << toUnicode((*iter));
+        for (TagLib::StringList::ConstIterator iter2 = tlist.begin(); iter2 != tlist.end(); ++iter2) {
+            values << toUnicode((*iter2));
         }
         qmap[TStringToQString(iter->first)] = values;
     }
diff --git a/src/preferencesDialog.cpp b/src/preferencesDialog.cpp
index 658a5a4..11de850 100644
--- a/src/preferencesDialog.cpp
+++ b/src/preferencesDialog.cpp
@@ -96,8 +96,8 @@ NPreferencesDialog::NPreferencesDialog(NPlayer *player, QWidget *parent) : QDial
 #ifdef _N_NO_UPDATE_CHECK_
     ui.autoCheckUpdatesContainer->hide();
 #else
-    connect(&NUpdateChecker::instance(), &NUpdateChecker::versionChanged, this,
-            &NPreferencesDialog::setVersionLabel);
+    connect(&NUpdateChecker::instance(), SIGNAL(versionChanged(QString)), this,
+            SLOT(setVersionLabel(QString)));
 #endif
 
 #if defined Q_OS_WIN || defined Q_OS_MAC
@@ -111,8 +111,8 @@ NPreferencesDialog::NPreferencesDialog(NPlayer *player, QWidget *parent) : QDial
     ui.quitOnCloseContainer->hide();
 #endif
 
-    QRegularExpression re("Container$");
-    for (QWidget *widget : ui.generalTab->findChildren<QWidget *>(re)) {
+    QRegExp re("Container$");
+    foreach (QWidget *widget, ui.generalTab->findChildren<QWidget *>(re)) {
         if (widget->objectName() == "fileFiltersContainer") {
             continue;
         }
@@ -158,7 +158,7 @@ NPreferencesDialog::NPreferencesDialog(NPlayer *player, QWidget *parent) : QDial
     ui.styleRestartLabel->setVisible(false);
     connect(ui.styleComboBox, SIGNAL(activated(int)), ui.styleRestartLabel, SLOT(show()));
 
-    ui.waveformTrackInfoTable->horizontalHeader()->setSectionResizeMode(QHeaderView::Stretch);
+    ui.waveformTrackInfoTable->horizontalHeader()->setResizeMode(QHeaderView::Stretch);
 
     int i = 0;
     foreach (int mib, QTextCodec::availableMibs()) {
@@ -398,7 +398,7 @@ void NPreferencesDialog::on_languageComboBox_activated(int index)
     QString newText = NI18NLoader::translate(locale.language(), "PreferencesDialog",
                                              "Switching languages requires restart");
     ui.languageRestartLabel->setText(
-        ui.languageRestartLabel->text().replace(QRegExp("(.*)&nbsp;.*"), "\\1&nbsp;" + newText));
+        ui.languageRestartLabel->text().replace(QRegExp("(.*)&nbsp;.*"), "\\\\1&nbsp;" + newText));
 }
 
 QString NPreferencesDialog::selectedContainer(N::PluginType type)
@@ -566,7 +566,9 @@ void NPreferencesDialog::loadSettings()
 
     // shortcuts >>
     QList<NAction *> actionList;
-    for (NAction *action : m_player->findChildren<NAction *>()) {
+    QList<NAction *> allActions = m_player->findChildren<NAction *>();
+    for (int i = 0; i < allActions.size(); ++i) {
+        NAction *action = allActions.at(i);
         if (action->objectName().isEmpty() || !action->isCustomizable()) {
             continue;
         }
@@ -678,6 +680,9 @@ void NPreferencesDialog::saveSettings()
     ui.shortcutEditorWidget->applyShortcuts();
     // << shortcuts
 
+    // Qt4: Explicitly sync settings to disk after all changes
+    NSettings::instance()->sync();
+
     emit settingsChanged();
 
     // systray check >>
diff --git a/src/settings.cpp b/src/settings.cpp
index 82c0f43..f7f0abf 100644
--- a/src/settings.cpp
+++ b/src/settings.cpp
@@ -18,10 +18,11 @@
 #include <QApplication>
 #include <QCoreApplication>
 #include <QDebug>
+#include <QDesktopServices>
 #include <QDir>
 #include <QSettings>
-#include <QStandardPaths>
 #include <QStyle>
+#include <QTextCodec>
 #include <QVariant>
 
 #include "action.h"
@@ -37,7 +38,8 @@ NSettings::NSettings(QObject *parent)
     Q_ASSERT_X(!m_instance, "NSettings", "NSettings instance already exists.");
     m_instance = this;
 
-    setIniCodec("UTF-8");
+    // Qt4: setIniCodec() requires QTextCodec* parameter
+    setIniCodec(QTextCodec::codecForName("UTF-8"));
 
     QString version = value("SettingsVersion").toString();
     if (version.isEmpty() || version < MIN_VERSION) {
@@ -81,13 +83,9 @@ NSettings::NSettings(QObject *parent)
     initValue("PitchStep", 0.01);
     */
 
-    {
-        QStringList fullScreenKeys;
-        foreach (QKeySequence seq, QKeySequence::keyBindings(QKeySequence::FullScreen)) {
-            fullScreenKeys << seq.toString();
-        }
-        initValue("Shortcuts/FullScreenAction", QStringList() << fullScreenKeys);
-    }
+    // Qt4 doesn't have QKeySequence::keyBindings or QKeySequence::FullScreen
+    // Use common fullscreen shortcuts manually
+    initValue("Shortcuts/FullScreenAction", QStringList() << "F11");
 
     initValue("PlaylistTrackInfo", "%F{ (%d)}");
     initValue("WindowTitleTrackInfo",
@@ -110,7 +108,7 @@ NSettings::NSettings(QObject *parent)
     initValue("DisplayLogDialog", true);
     initValue("DisplayTagEditorConfirmDialog", true);
     initValue("DisplayMoveToTrashConfirmDialog", true);
-    initValue("LastDirectory", QStandardPaths::standardLocations(QStandardPaths::MusicLocation));
+    initValue("LastDirectory", QDesktopServices::storageLocation(QDesktopServices::MusicLocation));
     initValue("ScrollToItem", true);
     initValue("LoopPlaylist", false);
     initValue("LoadNext", false);
@@ -178,7 +176,11 @@ void NSettings::setValue(const QString &key, const QVariant &value)
 void NSettings::initValue(const QString &key, const QVariant &defaultValue)
 {
     QVariant val = value(key, defaultValue);
-    val.convert(defaultValue.type());
+    // Qt4: convert() modifies in-place and returns bool success
+    if (!val.convert(defaultValue.type())) {
+        // Conversion failed, use default value
+        val = defaultValue;
+    }
     setValue(key, val);
 }
 
diff --git a/src/shortcutEditorWidget.cpp b/src/shortcutEditorWidget.cpp
index e341b51..a26f6d0 100644
--- a/src/shortcutEditorWidget.cpp
+++ b/src/shortcutEditorWidget.cpp
@@ -68,10 +68,10 @@ void NShortcutEditorWidget::init(const QList<NAction *> &actionList)
 
     resizeColumnToContents(Name);
     resizeColumnToContents(Description);
-    horizontalHeader()->setSectionResizeMode(Name, QHeaderView::Fixed);
-    horizontalHeader()->setSectionResizeMode(Description, QHeaderView::Fixed);
-    horizontalHeader()->setSectionResizeMode(Shortcut, QHeaderView::Stretch);
-    horizontalHeader()->setSectionResizeMode(GlobalShortcut, QHeaderView::Stretch);
+    horizontalHeader()->setResizeMode(Name, QHeaderView::Fixed);
+    horizontalHeader()->setResizeMode(Description, QHeaderView::Fixed);
+    horizontalHeader()->setResizeMode(Shortcut, QHeaderView::Stretch);
+    horizontalHeader()->setResizeMode(GlobalShortcut, QHeaderView::Stretch);
     horizontalHeader()->setStretchLastSection(true);
 }
 
diff --git a/src/src.pri b/src/src.pri
index 6ca941d..fd474f8 100644
--- a/src/src.pri
+++ b/src/src.pri
@@ -1,4 +1,4 @@
-QT += script gui svg core-private
+QT += script gui svg
 
 INCLUDEPATH += $$SRC_DIR $$SRC_DIR/interfaces
 
@@ -35,6 +35,8 @@ unix:!mac:PKGCONFIG += x11
 !no-skins {
     include($$SRC_DIR/skins/skins.pri)
     QT += uitools
+    # Qt4 on macOS requires explicit QtUiTools library linking
+    mac:LIBS += -lQtUiTools
     INCLUDEPATH += $$SRC_DIR/widgetCollection
     LIBS += -L$$SRC_DIR/widgetCollection -lwidget_collection
     PRE_TARGETDEPS += $$SRC_DIR/widgetCollection/libwidget_collection.a
@@ -57,7 +59,9 @@ unix:!mac:PKGCONFIG += x11
     FORMS += $$SRC_DIR/skins/native/form.ui
 }
 
-no-update-check:DEFINES += _N_NO_UPDATE_CHECK_
+# Qt4: Always disable update checking (MacPorts handles updates)
+DEFINES += _N_NO_UPDATE_CHECK_
+# no-update-check:DEFINES += _N_NO_UPDATE_CHECK_
 
 include(version.pri)
 DEFINES += _N_VERSION_=\""\\\"$${N_VERSION}\\\""\"
diff --git a/src/tagEditorDialog.cpp b/src/tagEditorDialog.cpp
index 1914d0e..bace3a7 100644
--- a/src/tagEditorDialog.cpp
+++ b/src/tagEditorDialog.cpp
@@ -29,6 +29,7 @@
 #include <QMetaEnum>
 #include <QPushButton>
 #include <QTextEdit>
+#include <QRegExp>
 
 NTagEditorDialog::NTagEditorDialog(const QString &file, QWidget *parent) : QDialog(parent)
 {
@@ -77,23 +78,15 @@ NTagEditorDialog::NTagEditorDialog(const QString &file, QWidget *parent) : QDial
         }
         ++i;
     }
-    connect(ui.encodingResetButton, &QPushButton::clicked, [=] {
-        ui.encodingComboBox->setCurrentIndex(m_encodingUtf8Index);
-        on_encodingComboBox_activated(-1);
-    });
-    connect(ui.editAsUtf8Button, &QPushButton::clicked, [=] {
-        ui.encodingComboBox->setCurrentIndex(m_encodingUtf8Index);
-        m_encodingPreviousIndex = m_encodingUtf8Index;
-        m_hasChanges = true;
-        setReadOnlyMode(false);
-    });
+    connect(ui.encodingResetButton, SIGNAL(clicked()), this, SLOT(onEncodingResetClicked()));
+    connect(ui.editAsUtf8Button, SIGNAL(clicked()), this, SLOT(onEditAsUtf8Clicked()));
     on_encodingComboBox_activated(-1);
 
     setWindowTitle("\"" + QFileInfo(file).fileName() + "\" — " + tr("Tag Editor"));
 
     m_coverReader->setSource(m_file);
     QList<QImage> images = m_coverReader->getImages();
-    for (QImage image : images) {
+    foreach (QImage image, images) {
         QLabel *label = new QLabel;
         label->setFixedSize(100, 100);
         label->setScaledContents(true);
@@ -107,11 +100,7 @@ NTagEditorDialog::NTagEditorDialog(const QString &file, QWidget *parent) : QDial
     ui.artworkListWidget->setMinimumHeight(111);
 
     ui.buttonBox->button(QDialogButtonBox::Reset)->setText(tr("Revert"));
-    connect(ui.buttonBox->button(QDialogButtonBox::Reset), &QPushButton::clicked, [=] {
-        ui.encodingComboBox->setCurrentIndex(m_encodingSettingsIndex);
-        readTags();
-        setReadOnlyMode(ui.encodingComboBox->currentIndex() != m_encodingUtf8Index);
-    });
+    connect(ui.buttonBox->button(QDialogButtonBox::Reset), SIGNAL(clicked()), this, SLOT(onRevertClicked()));
 
     exec();
 }
@@ -161,7 +150,7 @@ void NTagEditorDialog::readTags()
     }
 
     // create raw widgets for standard tags:
-    QRegularExpression widgetNameRegex("Tag");
+    QRegExp widgetNameRegex("Tag");
     m_tagReader->setSource(m_file);
     QMap<QString, QStringList> tags = m_tagReader->getTags();
     m_tagReader->setSource(""); // release the file
@@ -182,11 +171,7 @@ void NTagEditorDialog::readTags()
             QLineEdit *rawTagLineEdit = new QLineEdit(value);
             rawTagsFormLayout->addRow(label, rawTagLineEdit);
 
-            connect(rawTagLineEdit, &QLineEdit::textEdited, [=](const QString &newValue) {
-                m_hasChanges = true;
-                ui.buttonBox->button(QDialogButtonBox::Save)->setEnabled(true);
-                ui.buttonBox->button(QDialogButtonBox::Reset)->setEnabled(true);
-            });
+            connect(rawTagLineEdit, SIGNAL(textEdited(QString)), this, SLOT(onTagTextChanged()));
 
             if (label.isEmpty()) { // connect widgets only for the first tag value
                 continue;
@@ -196,36 +181,24 @@ void NTagEditorDialog::readTags()
             if (QLineEdit *standardTagLineEdit = ui.generalTab->findChild<QLineEdit *>(
                     widgetNamePrefix + "LineEdit")) {
                 standardTagLineEdit->setText(values.first());
-                QMetaObject::Connection connection =
-                    connect(standardTagLineEdit, &QLineEdit::textEdited,
-                            [=](const QString &newValue) {
-                                rawTagLineEdit->setText(newValue);
-                                m_hasChanges = true;
-                                ui.buttonBox->button(QDialogButtonBox::Save)->setEnabled(true);
-                                ui.buttonBox->button(QDialogButtonBox::Reset)->setEnabled(true);
-                            });
-                connect(rawTagLineEdit, &QObject::destroyed,
-                        [=] { QObject::disconnect(connection); });
-                connect(rawTagLineEdit, &QLineEdit::textEdited,
-                        [=](const QString &newValue) { standardTagLineEdit->setText(newValue); });
+
+                // Store bidirectional widget associations using properties
+                standardTagLineEdit->setProperty("rawTagWidget", qVariantFromValue((QObject*)rawTagLineEdit));
+                rawTagLineEdit->setProperty("standardTagWidget", qVariantFromValue((QObject*)standardTagLineEdit));
+                rawTagLineEdit->setProperty("isLineEdit", true);
+
+                connect(standardTagLineEdit, SIGNAL(textEdited(QString)), this, SLOT(onTagTextChanged()));
             } else if (QPlainTextEdit *standardTagPlainTextEdit =
                            ui.generalTab->findChild<QPlainTextEdit *>(widgetNamePrefix +
                                                                       "PlainTextEdit")) {
                 standardTagPlainTextEdit->setPlainText(values.first());
-                QMetaObject::Connection connection =
-                    connect(standardTagPlainTextEdit, &QPlainTextEdit::textChanged, [=] {
-                        rawTagLineEdit->setText(standardTagPlainTextEdit->toPlainText());
-                        m_hasChanges = true;
-                        ui.buttonBox->button(QDialogButtonBox::Save)->setEnabled(true);
-                        ui.buttonBox->button(QDialogButtonBox::Reset)->setEnabled(true);
-                    });
-                connect(rawTagLineEdit, &QObject::destroyed,
-                        [=] { QObject::disconnect(connection); });
-                connect(rawTagLineEdit, &QLineEdit::textEdited, [=](const QString &newValue) {
-                    QTextCursor cursor = standardTagPlainTextEdit->textCursor();
-                    standardTagPlainTextEdit->setPlainText(newValue);
-                    standardTagPlainTextEdit->setTextCursor(cursor);
-                });
+
+                // Store bidirectional widget associations using properties
+                standardTagPlainTextEdit->setProperty("rawTagWidget", qVariantFromValue((QObject*)rawTagLineEdit));
+                rawTagLineEdit->setProperty("standardTagWidget", qVariantFromValue((QObject*)standardTagPlainTextEdit));
+                rawTagLineEdit->setProperty("isLineEdit", false);
+
+                connect(standardTagPlainTextEdit, SIGNAL(textChanged()), this, SLOT(onTagTextChanged()));
             } else {
                 QMessageBox::critical(NULL, tr("Match error"),
                                       tr("No widget for tag: %1").arg(enumKey), QMessageBox::Close);
@@ -271,7 +244,8 @@ bool NTagEditorDialog::writeTags()
                 valueList.clear();
             }
             QLabel *label = qobject_cast<QLabel *>(item->widget());
-            tagName = label->text().chopped(1);
+            // Qt4 doesn't have QString::chopped(), use left() instead
+            tagName = label->text().left(label->text().length() - 1);
         }
         QString value = qobject_cast<QLineEdit *>(
                             rawTagsFormLayout->itemAt(i, QFormLayout::FieldRole)->widget())
@@ -295,7 +269,8 @@ bool NTagEditorDialog::writeTags()
             msgBox.exec();
         } else {
             QMessageBox msgBox(QMessageBox::Warning, tr("Save Fail"),
-                               tr("Saving aborted. Failed tags: %1").arg(unsaved.keys().join(", ")),
+                               // Qt4 QList doesn't have join(), convert to QStringList first
+                               tr("Saving aborted. Failed tags: %1").arg(QStringList(unsaved.keys()).join(", ")),
                                QMessageBox::Close, this);
             msgBox.exec();
         }
@@ -307,6 +282,80 @@ bool NTagEditorDialog::writeTags()
 
 NTagEditorDialog::~NTagEditorDialog() {}
 
+void NTagEditorDialog::onEncodingResetClicked()
+{
+    ui.encodingComboBox->setCurrentIndex(m_encodingUtf8Index);
+    on_encodingComboBox_activated(-1);
+}
+
+void NTagEditorDialog::onEditAsUtf8Clicked()
+{
+    ui.encodingComboBox->setCurrentIndex(m_encodingUtf8Index);
+    m_encodingPreviousIndex = m_encodingUtf8Index;
+    m_hasChanges = true;
+    setReadOnlyMode(false);
+}
+
+void NTagEditorDialog::onRevertClicked()
+{
+    ui.encodingComboBox->setCurrentIndex(m_encodingSettingsIndex);
+    readTags();
+    setReadOnlyMode(ui.encodingComboBox->currentIndex() != m_encodingUtf8Index);
+}
+
+void NTagEditorDialog::onTagTextChanged()
+{
+    m_hasChanges = true;
+    ui.buttonBox->button(QDialogButtonBox::Save)->setEnabled(true);
+    ui.buttonBox->button(QDialogButtonBox::Reset)->setEnabled(true);
+
+    QObject *senderWidget = sender();
+    if (!senderWidget) {
+        return;
+    }
+
+    // Check if this widget has an associated widget to sync with
+    QVariant rawTagVariant = senderWidget->property("rawTagWidget");
+    QVariant standardTagVariant = senderWidget->property("standardTagWidget");
+
+    if (rawTagVariant.isValid()) {
+        // This is a standard tag widget, update the raw tag widget
+        QLineEdit *rawTagLineEdit = qobject_cast<QLineEdit *>(
+            qvariant_cast<QObject*>(rawTagVariant));
+        if (rawTagLineEdit) {
+            QLineEdit *standardLineEdit = qobject_cast<QLineEdit *>(senderWidget);
+            QPlainTextEdit *standardPlainTextEdit = qobject_cast<QPlainTextEdit *>(senderWidget);
+
+            if (standardLineEdit) {
+                rawTagLineEdit->setText(standardLineEdit->text());
+            } else if (standardPlainTextEdit) {
+                rawTagLineEdit->setText(standardPlainTextEdit->toPlainText());
+            }
+        }
+    } else if (standardTagVariant.isValid()) {
+        // This is a raw tag widget, update the standard tag widget
+        QLineEdit *rawTagLineEdit = qobject_cast<QLineEdit *>(senderWidget);
+        if (rawTagLineEdit) {
+            QObject *standardWidget = qvariant_cast<QObject*>(standardTagVariant);
+            bool isLineEdit = senderWidget->property("isLineEdit").toBool();
+
+            if (isLineEdit) {
+                QLineEdit *standardLineEdit = qobject_cast<QLineEdit *>(standardWidget);
+                if (standardLineEdit) {
+                    standardLineEdit->setText(rawTagLineEdit->text());
+                }
+            } else {
+                QPlainTextEdit *standardPlainTextEdit = qobject_cast<QPlainTextEdit *>(standardWidget);
+                if (standardPlainTextEdit) {
+                    QTextCursor cursor = standardPlainTextEdit->textCursor();
+                    standardPlainTextEdit->setPlainText(rawTagLineEdit->text());
+                    standardPlainTextEdit->setTextCursor(cursor);
+                }
+            }
+        }
+    }
+}
+
 void NTagEditorDialog::onSaveClicked()
 {
     if (NSettings::instance()->value("DisplayTagEditorConfirmDialog").toBool()) {
@@ -316,7 +365,11 @@ void NTagEditorDialog::onSaveClicked()
                            tr("Do you want to save your changes?"),
                            QMessageBox::Save | QMessageBox::Cancel, this);
         msgBox.setDefaultButton(QMessageBox::Save);
-        msgBox.setCheckBox(checkBox);
+        // Qt4 doesn't have setCheckBox(), add checkbox manually to layout
+        QGridLayout *layout = qobject_cast<QGridLayout *>(msgBox.layout());
+        if (layout) {
+            layout->addWidget(checkBox, layout->rowCount(), 0, 1, layout->columnCount());
+        }
         int res = msgBox.exec();
 
         if (res != QMessageBox::Save) {
diff --git a/src/tagEditorDialog.h b/src/tagEditorDialog.h
index 08889d9..eeae7df 100644
--- a/src/tagEditorDialog.h
+++ b/src/tagEditorDialog.h
@@ -41,6 +41,7 @@ private:
     bool m_hasChanges;
     void readTags();
     bool writeTags();
+    void onTagTextChanged();
 
 public:
     NTagEditorDialog(const QString &file, QWidget *parent = 0);
@@ -50,6 +51,9 @@ private slots:
     void on_encodingComboBox_activated(int index);
     void onSaveClicked();
     void setReadOnlyMode(bool readOnly);
+    void onEncodingResetClicked();
+    void onEditAsUtf8Clicked();
+    void onRevertClicked();
 };
 
 #endif
diff --git a/src/trackInfoReader.cpp b/src/trackInfoReader.cpp
index 167f842..a648176 100644
--- a/src/trackInfoReader.cpp
+++ b/src/trackInfoReader.cpp
@@ -23,10 +23,11 @@ QString NTrackInfoReader::formatTime(int durationSec)
     int minutes = (durationSec - seconds) / 60;
     int hours = minutes / 60;
     minutes = minutes % 60;
+    // Qt4 doesn't have QString::asprintf() (added in Qt 5.5), use QString::sprintf() instead
     if (hours > 0) {
-        return QString::asprintf("%d:%02d:%02d", hours, minutes, seconds);
+        return QString().sprintf("%d:%02d:%02d", hours, minutes, seconds);
     } else {
-        return QString::asprintf("%d:%02d", minutes, seconds);
+        return QString().sprintf("%d:%02d", minutes, seconds);
     }
 }
 
diff --git a/src/updateChecker.cpp b/src/updateChecker.cpp
index 652b5fa..106e23b 100644
--- a/src/updateChecker.cpp
+++ b/src/updateChecker.cpp
@@ -33,7 +33,7 @@ NUpdateChecker &NUpdateChecker::instance()
 NUpdateChecker::NUpdateChecker()
 {
     m_networkManager = new QNetworkAccessManager(this);
-    connect(m_networkManager, &QNetworkAccessManager::finished, this, &NUpdateChecker::on_finished);
+    connect(m_networkManager, SIGNAL(finished(QNetworkReply*)), this, SLOT(on_finished(QNetworkReply*)));
 }
 
 QString NUpdateChecker::version() const
